<?php 
namespace Teknisa\MAN\Controllers\DataExporterImpl\ReportHandlers;

use Zeedhi\Framework\DTO\Response;

class RelProdModTipoconsReportHandler extends AReportHandler {
    const RELATORIO = 'vnd55020_relProdModTipoconsExport';
    
    public function buildNewRequest($request, Response $response) {
        
        $conditions = $this->relService->getParamsAsArray($request);
            
        $this->relService->setTCDandCDChangingKey($conditions, 'CDFILIAL', 'CDFILIAL');
        $this->relService->setTCDandCDChangingKey($conditions, 'CDLOJA', 'CDLOJA');
        $this->relService->setTCDandCDChangingKey($conditions, 'CDTIPOCONS', 'CDTIPOCONS');
        
        if(!array_key_exists('MODALIDADE', $conditions)) {
            $conditions['TMODALIDADE'] = 'T';
            $conditions['MODALIDADE'] = '';
        } else {
            $conditions['MODALIDADE'] = implode('_', $conditions['MODALIDADE']);
            $conditions['TMODALIDADE'] = 'E';
        }
        
        $this->relService->setIntervalAsDTINIandDTFIM($conditions, 'DTENTRVENDA', 'DATAINI', 'DATAFIN');
        
        unset($conditions['NRORG']);
        
        $newRequest = $this->relService->createNewZeedhiFilterRequestObject($request, self::RELATORIO, $conditions);
        
        return [$newRequest, $response];
    }
}