<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\Controller\CrudWithParameterBag;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Notification;
use Teknisa\MAN\Utilities\Util;

use Teknisa\MAN\Services\ParamAppConsumidorService;

class ParamAppConsumidor extends CrudWithParameterBag {
    
    protected $util;
    protected $parameterBag;
    protected $dataSourceNameArray = array (
        'filterParamGeralApp'      => 'vnd05600_paramappconsumidor',
        'filterParamFilialApp'     => 'vnd05600_paramappconsumidor_filial',
        'filterParamFilialAppMult' => 'vnd05600_paramappconsumidor_cadastroautomatico'
    );
    protected $parameterBagColumnsArray = array (
        'filterParamGeralApp'      =>  array('NRORG'),
        'filterParamFilialApp'     =>  array('NRORG', 'CDFILIAL'),
        'filterParamFilialAppMult' =>  array('NRORG', 'CDFILIAL')
    );
    protected $paramAppConsumidorService;
    
    public function __construct (Manager $dataSourceManager, ParameterBag $parameterBag, ParamAppConsumidorService $paramAppConsumidorService, Util $util) {
        parent::__construct($dataSourceManager, $parameterBag);
        $this->paramAppConsumidorService = $paramAppConsumidorService;
        $this->util = $util;
    }
    
    public function findParamAppConsumidor(DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName = $this->dataSourceNameArray['filterParamGeralApp'];
        $this->parameterBagColumns = $this->parameterBagColumnsArray['filterParamGeralApp'];
        parent::find($request, $response);
    }
    
    public function saveParamAppConsumidor(DTO\Request\DataSet $request, DTO\Response $response) {
        $this->dataSourceName = $this->dataSourceNameArray['filterParamGeralApp'];
        try {
            $dataSet = $request->getDataSet();
            $dataSet->setDataSourceName($this->dataSourceName);
            $persistedRows = $this->dataSourceManager->persist($dataSet);
            $response->addDataSet(new DataSet($this->dataSourceName, $persistedRows));
        } catch (\Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode(), $e->getTraceAsString()));
        }
    }
    
    public function findParamAppConsumidorFilial(DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName = $this->dataSourceNameArray['filterParamFilialApp'];
        $this->parameterBagColumns = $this->parameterBagColumnsArray['filterParamFilialApp'];
        parent::find($request, $response);
    }
    
    public function saveParamAppConsumidorFilial(DTO\Request\DataSet $request, DTO\Response $response) {
        $this->dataSourceName = $this->dataSourceNameArray['filterParamFilialApp'];
        try {
            $dataSet = $request->getDataSet();
            $dataSet->setDataSourceName($this->dataSourceName);
            $persistedRows = $this->dataSourceManager->persist($dataSet);
            $response->addDataSet(new DataSet($this->dataSourceName, $persistedRows));
        } catch (\Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode(), $e->getTraceAsString()));
        }
    }
    
    public function findParamAppConsumidorFilialMult(DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName = $this->dataSourceNameArray['filterParamFilialAppMult'];
        $this->parameterBagColumns = $this->parameterBagColumnsArray['filterParamFilialAppMult'];
        parent::find($request, $response);
    }

    
    public function saveParamAppConsumidorFilialMult(DTO\Request\DataSet $request, DTO\Response $response) {
        $this->dataSourceName = $this->dataSourceNameArray['filterParamFilialAppMult'];
        try {
            $dataSet = $request->getDataSet();
            $dataSet->setDataSourceName($this->dataSourceName);
            $persistedRows = $this->dataSourceManager->persist($dataSet);
            $response->addDataSet(new DataSet($this->dataSourceName, $persistedRows));
        } catch (\Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode(), $e->getTraceAsString()));
        }
    }

    
}  